package eu.flygare.utbildning.reactive;

import io.smallrye.mutiny.Uni;
import java.util.LinkedList;
import java.util.List;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

@Path("/hello")
public class RestResource {
    
    @GET
    @Produces(MediaType.TEXT_PLAIN)
    public String hello() {
        return "Hello from RESTEasy Reactive";
    }
    
    @GET
    @Path("/sample")
    @Produces(MediaType.APPLICATION_JSON)
    public Uni<RestEntity> getSample() {
        RestEntity res = new RestEntity();
        res.subEntity = new SubEntity();
        res.subEntity.name = "Kalle";
        res.subEntity.date = "20220510";
        res.id = "12345";
        return Uni.createFrom().item(res);
    }
    
    @GET
    @Path("/response")
    @Produces(MediaType.APPLICATION_JSON)
    public Uni<List<RestEntity>> getResponse() {
        List<RestEntity> res = new LinkedList<>() {
            {
                add(new RestEntity("2", "kalle", "20220501"));
                add(new RestEntity("3", "anders", "20220502"));
                add(new RestEntity("4", "emil", "20220503"));
            }
        };
        System.out.println("Returning list with " + res.size() + " elements");
        return Uni.createFrom().item(res);
    }
    
}
